<template>
  <v-row dense>
    <GCol cols="12">
      <GTextField
        v-model="value._attr.refType"
        i18n="dcc.common.attributes.refType"
        attr-ref-type
      />
    </GCol>
    <GCol cols="12">
      <Contact
        ref="contact"
        v-model="value.person"
        not-strict
        :card="false"
        location-card
        i18n="dcc.administrativeData.respPersons.person"
      />
    </GCol>
    <GCol cols="12">
      <RichContent
        v-if="value.description"
        ref="description"
        v-model="value.description"
        i18n="dcc.common.richContentType.description.title"
        optional
        level="second"
        @delete="deleteRichContent"
      />
    </GCol>
    <GCol cols="12">
      <XmlTextField
        v-model="value.role"
        i18n="dcc.administrativeData.respPersons.role"
        validate="notEmptyStringType"
      />
    </GCol>
    <GCol cols="12">
      <XmlCheckbox
        v-model="value.mainSigner"
        i18n="dcc.administrativeData.respPersons.mainSigner"
      />
    </GCol>
    <GCol cols="12" md="4">
      <XmlCheckbox
        v-model="value.cryptElectronicSeal"
        i18n="dcc.administrativeData.respPersons.cryptElectronicSeal"
      />
    </GCol>
    <GCol cols="12" md="4">
      <XmlCheckbox
        v-model="value.cryptElectronicSignature"
        i18n="dcc.administrativeData.respPersons.cryptElectronicSignature"
      />
    </GCol>
    <GCol cols="12" md="4">
      <XmlCheckbox
        v-model="value.cryptElectronicTimeStamp"
        i18n="dcc.administrativeData.respPersons.cryptElectronicTimeStamp"
      />
    </GCol>
  </v-row>
</template>

<script>
import { RichContentType } from "@d-ptb/dcc-js";
import XmlCheckbox from "../../App/Form/XML/XmlCheckbox";
import Contact from "../Common/Contact";
import XmlTextField from "~/components/App/Form/XML/XmlTextField";
import RichContent from "~/components/DCC/Common/RichContent";
import GCol from "~/components/App/Common/GCol";
import GTextField from "~/components/App/Form/gTextField";
import { insertIf } from "~/assets/util/general";

export default {
  name: "RespPerson",
  components: {
    GTextField,
    GCol,
    RichContent,
    XmlTextField,
    Contact,
    XmlCheckbox,
  },
  props: {
    value: Object,
    updateAvailableElements: Function,
    i18nBase: {
      type: String,
      default: "dcc.administrativeData.respPersons",
    },
  },
  computed: {
    availableElements() {
      return [
        {
          text: this.$t(`dcc.common.richContentType.description.title`),
          value: "description",
          addElement: () => this.addElement("description"),
        },
      ].filter((x) => !this.blacklist.includes(x.value));
    },
    blacklist() {
      return [...insertIf(this.value.description, "description")];
    },
  },
  watch: {
    availableElements: {
      handler() {
        this.$nextTick(() =>
          this.updateAvailableElements(this.availableElements)
        );
      },
      immediate: true,
      deep: true,
    },
  },
  methods: {
    addElement(element) {
      switch (element) {
        case "description":
          this.$set(this.value, "description", new RichContentType());
          break;
      }
      this.$nextTick(() => {
        this.$refs[element].$el.scrollIntoView({
          behavior: "smooth",
        });
      });
    },
    deleteRichContent() {
      confirm(
        this.$t("dcc.common.richContentType.description.confirmRemove")
      ) && this.$delete(this.value, "description");
    },
  },
};
</script>
